
module FREQ_TEST  ( 
   input          RESET_N , 
   input          BUTTON , 
	
	input          CLK_50  , 
	input          CLK_T    ,
	output [31:0 ]FREQ_MEM  , 
	output [ 6:0] FREQ1_HEX ,    
	output [ 6:0] FREQ0_HEX  ,
   output        ERROR_FG	
);

wire HZ_1 ; 
CLOCKMEM ck1(  .CLK (  CLK_T  ) ,. CLK_FREQ ( 10000000 ) , .CK_1HZ (HZ_1 ) ) ;  

//---
reg          rHZ_1  ; 
reg [ 31:0 ] T ; 
reg [ 31:0 ] T_CNT  ; 
wire [31:0]  TN ; 
assign TN = T_CNT/6000000 ; 
//-- 
always @ ( negedge RESET_N or posedge  CLK_50  ) begin
if (!RESET_N) begin 
      rHZ_1 <=HZ_1 ; 
	  { T , T_CNT } <= {32'h0 ,32'h0 } ; 
end 
else begin 
   rHZ_1 <= HZ_1 ; 
         if  ( ( rHZ_1) && ( !HZ_1  ))  {  T , T_CNT } <= { TN ,32'h0 } ;  	 
   else  if ( T_CNT > 200000000 ) 
	       T <= 32'h00  ;       
	else  T_CNT  <= T_CNT+1 ; 
end 
end 

//------
wire [7:0] BCD ; 
HEX2BCD  h(
 .iCLK_50 (CLK_50)  ,
 .iHEX ( T[7:0] ) ,  //8'h63//  input  [7:0]iHEX,
 .oBCD ( BCD    )    //output reg [7:0]oBCD,
);


SEG7_LUT_V	 v1( . iDIG(BCD [7:4] ), . oSEG ( FREQ1_HEX) ) ;  
SEG7_LUT_V	 v2( . iDIG(BCD [3:0] ), . oSEG ( FREQ0_HEX) ) ;  



//-- 0.1% CHECK
PPS_CHECK tr( 
 .CLK_50  ( CLK_50 ), 
 .SMA_IN    ( HZ_1    ),// SW[1]?SMA_CLKIN : PPS_CLK   ), 
 .RESET_N ( BUTTON ),
 .ERROR_FG( ERROR_FG) //000: ok  , 110 :higher ,101:lower  

);


endmodule 

