module PPS_10MHZ_CHECK  ( 
   input          RESET_N , 
	input          CLK_50 , 
	input          CLK_10M ,
	input          CLK_PPS ,
	
	output   [31:0] RESULT_CNT ,
	output           READY  , 
	
	
	
	output [ 6:0]  FREQ1_HEX ,    
	output [ 6:0]  FREQ0_HEX,
	output [ 23:0]  SEC_CNT 
);

wire  [31:0]HEX  ; 
wire  [7:0 ] BCD ; 
wire  [31:0]ERR_CNT  ; 

//---PPS vs 10Mhz 
PPSVS10MHZ pr(  
   .CLK_50  (CLK_50)  , 
	.RESET_N (RESET_N), 
	.CLK_10M (CLK_10M),
	.CLK_PPS (CLK_PPS),
	.ERR_CNT (ERR_CNT),
	.RESULT_CNT (RESULT_CNT),
	.READY      (READY     ),
	.SEC_CNT    (SEC_CNT)
);

		
//---Display HEX 
HEX2BCD  h(
 .iCLK_50 ( CLK_PPS      ),
 .iHEX    ( ERR_CNT[7:0] ), 
 .oBCD    ( BCD      )  
);

//---
SEG7_LUT_V	 v1( . iDIG(BCD [7:4] ), . oSEG ( FREQ1_HEX) ) ;  
SEG7_LUT_V	 v2( . iDIG(BCD [3:0] ), . oSEG ( FREQ0_HEX) ) ;  


endmodule 

