module UART_ST  (
  input   [31:0]    PPS_RESULT_CNT ,
  input   [23:0]  SEC_CNT , 
  input             CLK,
  input             RESET_N  ,
  output reg        ADDRESS ,
  
  //--ALTERA IP IF
  output reg        CS ,
  output    [3:0]   BYTE_ENABLE ,
  output reg        READ,
  output reg        WRITE,
  output reg [31:0] WRITEDATA ,
  input             IRQ     ,
  input   [31:0]    READDATA,
  output reg        READY  ,  //ST_READY 
   
  //--SYSTEM 
  output reg [7:0]  ST 	,
  output     [7:0]  WRCM2,
  output reg [7:0]  CNT ,
  output     [7:0]  RD_BUFF_CNT,
  
  
  output reg [7:0]  MESSAGE,
  output reg [7:0]  WR_LEN ,
  output            WI ,RI,
  
  output            TR   
  
 
);
//=======================================================
//  REG/WIRE declarations
//======================================================= 
//---------------------------------------------------------------------

parameter  RE=1'b1; //1 :RE R/W Interrupt-enable bit for read interrupts  BIT0 
parameter  WE=1'b1; //1 :WE R/W Interrupt-enable bit for write interrupts BIT1
parameter  TIME_BASE      = 125000000;
parameter  S1             = TIME_BASE / 10; 
parameter  MASSEGE_LN_WR2 = 20;

reg [31:0] DELAY ; 


//=======================================================
//  Structural coding
//=======================================================
assign TR = (  MESSAGE ==3 )?1:0 ; 


//--BUS -- 
  assign  ASCII_TX    = WRITEDATA[7:0] ; 
 
  //assign  ASCII_RX    = READDATA[7:0] ; 
  //assign  RD_BUFF_CNT = READDATA[23:16] ; 
  //assign  {WI,RI }    = ADDRESS ? READDATA[9:8]  : 2'h0 ; 

 assign BYTE_ENABLE = 4'hf ; 
//------------st ------
always @(negedge RESET_N or posedge  CLK ) 
if ( !RESET_N) begin
  READY      <=0; 
  ST         <=0; 
  ADDRESS    <=0;  
  CS         <=0;  
  READ       <=0;  
  WRITE      <=0;  
  CNT        <=0;  
  WRITEDATA  <=32'h0;  
  DELAY      <=0;  
  MESSAGE    <=2; 
end
else begin 
  case (ST) 
  0:begin  
           if  (DELAY != 2 )  begin 
			     DELAY <=DELAY+1 ; 
			  //---to clear UART_IP read buffer--- 
				  CS        <=~CS   ;  
              READ      <=~READ ;  
           //---to clear VIEW RAM --- 				  

			   end 
			   else  begin 

			
              ADDRESS   <= 1 ;  
              WRITEDATA <= {WE , RE }  ;  //SET WRITE READ BUFFER INTERRUPT 
				  ST        <= 1 ;       				
				  READY     <= 1 ; 
				  MESSAGE    <=2; 
				
			 end 
	end  
 1:begin  CS <=1;        WRITE <=1;ST<= 2;  end 
 2:begin  CS <=0;        WRITE <=0;ST<= 3;  end 

 
 //----- WRITE  TO  PC 
 3:begin
              if ( MESSAGE ==2 ) begin WR_LEN<= MASSEGE_LN_WR2; end
              ADDRESS<=0 ;  
				  ST  <=4;  
				  CNT <=0 ; 
				  end  
 4:begin      
              ST  <=5;  
				  end  
				 
 5:begin 
       CS    <=1; 
		 WRITE <=1; 
		 ST    <=6; 
		 //
          if ( MESSAGE ==2 ) begin  WRITEDATA <= WRCM2[7:0] ;   end			
	end 
 6:begin  
        CS    <=0; 
		  WRITE <=0 ;  		  
      if ( CNT != WR_LEN) begin 
		       CNT <=CNT+1 ; 
	          ST<=5; 
		end 
	  else begin 
	       ST  <=7; 
			 CNT <=0 ;	 
		end 
   end  //-----END WRITE  ------- 
	
 7:begin  
     ST  <= ST ; 
   end  	
 
 endcase   
end


//****************************************************

//====== TX :SEND TO ESP8266 MESSAGE DATA  TABEL ======
 WRITE_STEP2  stp2( 
     .ADDRESS  ( CNT), 
     .ROM_DATA ( WRCM2),
	  .PPS      ( PPS_RESULT_CNT),
	  .SEC_CNT  ( SEC_CNT ) 
 );
 

endmodule 
